/* drc grammar for attribute file */

%{

#include "d.h"
#include <stdio.h>

/* extern FILE *attdrcin; */
#define ATTDRCDEBUG   1   /* pretty debugging code */


int mval, cval, wtype, ctype, atype, param;

%}

/*************** tokens ***********/

%token ATTRIBUTES IDENTIFIER STR_LITERAL INT_LITERAL
%token PRECONDITION POSTCONDITION PRERESTRICTION POSTRESTRICTION POSTS
%token WARNINGS ASSERT NEGATE SET UNSET NOT COPY MERGE TRUEVAL FALSEVAL

%union { 
    char str[100];
    int  ival;
    DRV  value;
}

%type <str> IDENTIFIER STR_LITERAL 
%type <ival> INT_LITERAL
%type <value> initval

%start top

%%

top        : attrdef ldeflist
           ;

attrdef    : ATTRIBUTES '=' '{' attrlist '}'
           ;
  
attrlist  : /* null */ 
           | attrlist IDENTIFIER STR_LITERAL initval { addattr($2, $3, $4); }
           ;

initval    :  TRUEVAL    { $$ = DRC_TRUE;   }
           |  ASSERT     { $$ = DRC_ASSERT; }
           |  NEGATE     { $$ = DRC_NEGATE; }
           |  UNSET      { $$ = DRC_UNSET;  }
           |  SET        { $$ = DRC_SET;    }
           |  NOT NEGATE { $$ = DRC_NOT_NEGATE; }
           |  NOT ASSERT { $$ = DRC_NOT_ASSERT; }
           |  FALSEVAL   { $$ = DRC_FALSE; } 
           ;

ldeflist   : /* null */
           | ldeflist layerdef /* really want it the other way.... */
           ;

layerdef   : IDENTIFIER 
              { add_to_lnames($1); mval = 0; cval = 0; } 
            ':' qualifiers 
              { setattrqual(mval, cval); }
            '{' conditions '}' 
           ;

qualifiers : IDENTIFIER '[' param_rlist ']' mc 
              { set_realm_type($1); } 
           ;

param_rlist: /* null */ 
           | param_rlist IDENTIFIER  { addrparam($2); }
           ;

mc         : /* null */ 
           | MERGE            { mval = 1; }
           | COPY             { cval = 1; }
           | MERGE COPY       { mval = 1; cval = 1; }
           | COPY MERGE       { mval = 1; cval = 1; }
           ;

conditions : /* null */
           | conditions cond 
           ;

cond       : condtype { wtype = 0; } warnings assertlist 
           ;

condtype   : PRECONDITION                 { ctype = 1; }
           | POSTCONDITION  INT_LITERAL   { ctype = 2; param = $2; }
           | POSTCONDITION                { ctype = 3; }
           | PRERESTRICTION  INT_LITERAL  { ctype = 4; param = $2; }
           | PRERESTRICTION               { ctype = 5; }
           | POSTRESTRICTION              { ctype = 6; }
           | POSTS                        { ctype = 7; }
           ;

warnings   : WARNINGS                     { wtype = 1; }
           | /* null */                   { wtype = 0; }
           ;

assertlist: /* null */
           | assertprop assertlist
           ;

assertprop : a_type proplist
           ;

a_type     : ASSERT                       { atype = DRC_ASSERT; }
           | NEGATE                       { atype = DRC_NEGATE; }
           | SET                          { atype = DRC_SET; }
           | UNSET                        { atype = DRC_UNSET; }
           | NOT ASSERT                   { atype = DRC_NOT_ASSERT; }
           | NOT NEGATE                   { atype = DRC_NOT_NEGATE; }
           | TRUEVAL                      { atype = DRC_TRUE; }
           | FALSEVAL                     { atype = DRC_FALSE; }
           ;

proplist : IDENTIFIER                     { do_props($1,atype,ctype,param,wtype); }
         | proplist IDENTIFIER            { do_props($2,atype,ctype,param,wtype); }
         ;

%%

int attdrcwrap (void)
{
  return(1);
}

int attdrcerror (char *s)
{
  return 0;
}

