%{

#include "d.h"
#include "attr-gram.h"

%}

identifier       [a-zA-Z_][0-9a-zA-Z_]*
integer_const    [1-9][0-9]*
string_const     (\"([^\n"\\]|(\\.)|(\\\n))*\")
blanks           [ \t\f\v\n]

%%

#.*                      { /* ignore */ } 

"{"                      { return(attdrctext[0]); }
"}"                      { return(attdrctext[0]); }
"["                      { return(attdrctext[0]); }
"]"                      { return(attdrctext[0]); }
"="                      { return(attdrctext[0]); }
":"                      { return(attdrctext[0]); }

attributes               { return(ATTRIBUTES); }
copy                     { return(COPY); }
merge                    { return(MERGE); }
preconditions?           { return(PRECONDITION); }
postconditions?          { return(POSTCONDITION); }
prerestrictions?         { return(PRERESTRICTION); }
postrestrictions?        { return(POSTRESTRICTION); }
posts?                   { return(POSTS); }
warnings?                { return(WARNINGS); }

assert                   { return(ASSERT); }
negate                   { return(NEGATE); }
set                      { return(SET); }
unset                    { return(UNSET); }
not                      { return(NOT); }
true                     { return(TRUEVAL); }
false                    { return(FALSEVAL); } 

{string_const}           { strcpy(attdrclval.str,attdrctext); return(STR_LITERAL); }
{integer_const}          { sscanf(attdrctext,"%d",&attdrclval.ival); return(INT_LITERAL); }
{identifier}             { strcpy(attdrclval.str,attdrctext); return(IDENTIFIER); }

{blanks}+                { }
.                        { fprintf(stderr,
                                   "unknown character |%c| (%d) ignored\n", 
                                   (char) *attdrctext, (int) *attdrctext); }
%%
